// Gmail Manager
// By Todd Long <longfocus@gmail.com>
// http://www.longfocus.com/firefox/gmanager/

var GM_gAccounts = {
  _action: null,
  _account: null,
  
  load: function()
  {
    var args = window.arguments;
    
    // Sets the action
    this._action = args[0];
    
    if (args.length > 1)
    {
      this._account = GM_getManager().getAccount(args[1]);
      
      GM_getEBI("gm-accounts-email").value = this._account.email;
      GM_getEBI("gm-accounts-email").size = this._account.email.length;
    }
    
    switch (this._action)
    {
      case "add":
        GM_getEBI("gm-accounts-header").value = GM_getBundleString("accounts-add");
        GM_getEBI("gm-accounts-email").value = "";
        GM_getEBI("gm-accounts-email").select();
        GM_getEBI("gm-accounts-password-row").hidden = false;
        GM_getEBI("gm-accounts-remember").hidden = false;
        GM_getEBI("gm-accounts-login").hidden = false;
        break;
      case "remove":
        GM_getEBI("gm-accounts-header").value = GM_getBundleString("accounts-remove");
        GM_getEBI("gm-accounts-email").disabled = true;
        GM_getEBI("gm-accounts-login").checked = false;
        break;
      case "pass":
        GM_getEBI("gm-accounts-header").value = GM_getBundleString("accounts-login");
        GM_getEBI("gm-accounts-email").disabled = true;
        GM_getEBI("gm-accounts-password-row").hidden = false;
        GM_getEBI("gm-accounts-password").disabled = false;
        GM_getEBI("gm-accounts-password").select();
        GM_getEBI("gm-accounts-remember").hidden = false;
        GM_getEBI("gm-accounts-login").checked = true;
        break;
    };
  },
  
  action: function(aEvent)
  {
    // Password
    GM_getEBI("gm-accounts-password").disabled = (GM_getEBI("gm-accounts-email").value == "");
    GM_getEBI("gm-accounts-remember").disabled = (GM_getEBI("gm-accounts-password").value == "");
  },
  
  accept: function()
  {
    var type = "gmail";
    var email = GM_getEBI("gm-accounts-email").value;
    var password = GM_getEBI("gm-accounts-password").value;
    var remember = GM_getEBI("gm-accounts-remember").checked;
    var success = true;
    
    switch (this._action)
    {
      case "add":
        if (email.indexOf("@") == -1)
        {
          alert(GM_getBundleString("accounts-full-email"));
          return;
        }
        
        // Adds account
        success = GM_getManager().addAccount(type, email, password, remember, email);
        break;
      case "remove":
        // Removes account
        GM_getManager().removeAccount(email);
        break;
      case "pass":
        // Updates account
        GM_getManager().updateAccount(email, password, remember, this._account.alias);
        break;
    };
    
    // Close window
    this.cancel();
    
    if (success)
    {
      var observer = GM_CC["@mozilla.org/observer-service;1"].getService(GM_CI.nsIObserverService);
      
      // Notify account change
      observer.notifyObservers(null, GM_NOTIFY_ACCOUNT_CHANGE, this._action);
      
      // Notify account login
      if (GM_getEBI("gm-accounts-login").checked)
        observer.notifyObservers(null, GM_NOTIFY_ACCOUNT_LOGIN, email);
    }
  },
  
  cancel: function()
  {
    self.close();
  }
}